

/*
 * 1.将这个组件挂在scrollView上来实现单元格的复用（类似于TableView）,这是横向滑动的单元格，从左到右
 * 2.在使用前将scrollView/view的Anchor设置为（0，0.5）
 * 3.在使用前将scrollView/view/content的Anchor设置为(0,0.5)
 * 4.使用者只需要关注getItem这个函数即可
 * 5.不要在 scrollView/view/content 上挂载widget组件
 *
 * */
cc.Class({
    extends: cc.Component,

    properties: {
        // foo: {
        //    default: null,      // The default value will be used only when the component attaching
        //                           to a node for the first time
        //    url: cc.Texture2D,  // optional, default is typeof default
        //    serializable: true, // optional, default is true
        //    visible: true,      // optional, default is true
        //    displayName: 'Foo', // optional
        //    readonly: false,    // optional, default is false
        // },
        // ...
        itemWidth:80,
        itemTotal:100,
        content:cc.Node,
        scrollView:cc.ScrollView,
        itemPrefab:cc.Prefab,
        itemCtrlName:'',

        _sourceData:[],//存放数据源的数组
        _reuseArray:[],
        _usedArray:[],
    },

    // use this for initialization
    onLoad: function () {
        this.reload();
    },

    onDestroy:function () {

    },


    getItem:function(index){
        var item = this._reuseArray.pop();
        if(item == null){
            item = cc.instantiate(this.itemPrefab);
        }
        item.getComponent(this.itemCtrlName).reuse();
        return item;
    },

    update:function(dt){

        if(this.scrollView.node.active == false)
            return;

        var offsetX =  this.scrollView.getContentPosition().x;
        var leftX = -offsetX;
        var rightX = this.scrollView.node.width+leftX;

        var startIndex =  Math.floor(Math.floor(leftX)/this.itemWidth) -1;
        var endIndex =  Math.ceil(Math.floor( rightX)/this.itemWidth)+1;
        if(startIndex < 0) startIndex = 0;
        if(endIndex > this.itemTotal-1) endIndex = this.itemTotal -1;

        var temp =_.groupBy(this._usedArray,function(item){
            if( item.cellIndex >= startIndex && item.cellIndex <=endIndex)
                return 'usedAarray';
            else
                return 'reusedArray';
        }.bind(this));
        this._usedArray = temp.usedAarray || [];

        _.each(temp.reusedArray,function (item) {
            item.parent = null;
            item.getComponent(this.itemCtrlName).unuse();
            this._reuseArray.push(item);
        }.bind(this));



        for(var i = startIndex;i<=endIndex;i++){
            var exists = _.some(this._usedArray,function(item){
                return item.cellIndex == i;
            });

            if(exists == false){
                var item = this.getItem(i);
                if(item == null){
                    cc.log('sss');
                }
                item.cellIndex = i;
                item.x = (i+0.5)* this.itemWidth;
                item.y = 0;
                item.parent = this.content;
                this._usedArray.push(item);
            }
        }
    },

    reload:function(){
        for(var i = 0;i<this._usedArray.length;i++){
            this._usedArray[i].parent = null;
            this._usedArray[i].getComponent(this.itemCtrlName).unuse();
            this._reuseArray.push(this._usedArray[i]);
        }
        this._usedArray = [];
        this.itemTotal = this._sourceData.length;
        var width =  Math.max( this.scrollView.node.getContentSize().width,this.itemWidth * this.itemTotal);
        var height = this.scrollView.node.height;
        this.content.width = width;
        this.scrollView.scrollToLeft();
    },
    
    clearReuserArray:function () {
        for(let i=0;i<this._reuseArray.length;i++){
            this._reuseArray[i].destroy();
        }
    },

    // called every frame, uncomment this function to activate update callback
    // update: function (dt) {

    // },
});
